function demo1
% L170101
% Esitelln ksitteet signaali x(t), sekvenssi x[n],
%  muutamia signaalioperaatioita ja suodatus

[y, fs, nbits] = wavread('nayte2.wav'); % lue signaali
t = linspace(0, length(y)/fs, length(y));
plot(t, y);      % voidaan piirt
title('Signaali x(t)');
xlabel('aika (sekunnit)');
fprintf(1,'Signaali x(t) piirretty! PAUSE\n');
pause;

stem(t(20000:21000),y(20000:21000));  %diskreetti, digitaalinen
title('...joka tietokoneessa on digitaalinen sekvenssi x[n]');
xlabel('aika (sekunnit)');
fprintf(1,'Sekvenssi x[n] piirretty! PAUSE\n');
pause;

y(1:10000)  %printtaa pelkki numeroita
fprintf(1,'...pelkki numeroita, mutta kuunnellaan\n');
pause;

soundsc(y, fs);  %..mutta kuuntele! 
y(1:10000) % eli vain numeroita, mutta kun kaiuttimesta 
pause(5);
fprintf(1,'Sekvenssi pelkki numeroita, voidaan soittaa eri nopeuksilla\n');
pause;

kerroin = input('Anna nopeutus/hidastuskerroin: ');
% voit ksitell signaalia. Koska pelkki numeroita, voit sst aikaa
soundsc(y, kerroin*fs);
% !!! sama taajuus, mutta hitaampi tai nopeampi NOKIA
fprintf(1,'...viel muita operaatioita...\n');
pause;

fprintf(1,'Fade-out, nen vaimentaminen ajan myt\n');
win = linspace(1,0,length(y));
y2 = y.*win'; % vaimentaminen, fade out
soundsc(y2,fs); 
plot(t,y2);
title('Fade-out, vaimennettu signaali x(t)');
xlabel('aika (sekunnit)'); 
pause;

fprintf(1,'Koska vain lukuja, voidaan vaihtaa jrjestys vastakkaiseksi\n');
%knnetn
plot(t,flipud(y2));
soundsc(flipud(y),fs);
pause;

fprintf(1,'ness on paljon suhinaa\n');
fprintf(1,'Tehdn alipstsuodin, joka pst lpi vain puhelintaajuudet.\n');
fprintf(1,'Aikatason nopeat muutokset signaalissa vastaavat korkeita taajuuksia.\n');
fprintf(1,'Aikatason hitaat muutokset ovat matalia taajuuksia.\n');
pause;

Wp = 2*2800/fs;
Ws = 2*3300/fs;
Rp = 1;
Rs = 40;
[N,Wn] = ellipord(Wp, Ws, Rp, Rs);
[b,a] = ellip(N, Rp, Rs, Wn);

fprintf(1,'Tehtiin elliptinen alipstsuodin\n');
[hh,ww]=freqz(b,a,1024,fs);   % suotimen amplitudi- ja vaihevaste
plot(ww,abs(hh).^2);
pause;

fprintf(1,'Suodatetaan suhinainen signaali...\n');
% Seuraavalla komennolla suodatetaan "nayte2" alipstsuotimella
ysuod = filter(b,a,y);  
fprintf(1,'...ja saadaan aikaan alipstsuodatettu "puhelinsignaali"\n');
soundsc(ysuod,fs);
%soundsc(y,fs);

